package font;

import font.TrueTypeFont;
import java.nio.FloatBuffer;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.util.StringUtils;
import org.lwjgl.BufferUtils;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.vector.Matrix4f;

public class FontHelper {

   public static void drawString(String s, float x, float y, TrueTypeFont font, float scaleX, float scaleY, float ... rgba) {
      Minecraft mc = Minecraft.getMinecraft();
      ScaledResolution sr = new ScaledResolution(mc.gameSettings, mc.displayWidth, mc.displayHeight);
      if(!mc.gameSettings.hideGUI) {
         byte amt = 1;
         if(sr.getScaleFactor() == 1) {
            amt = 2;
         }

         FloatBuffer matrixData = BufferUtils.createFloatBuffer(16);
         GL11.glGetFloat(2982, matrixData);
         Matrix4f matrix = new Matrix4f();
         matrix.load(matrixData);
         set2DMode();
         y = (float)mc.displayHeight - y * (float)sr.getScaleFactor() - (float)(font.getLineHeight() / amt);
         GL11.glEnable(3042);
         GL11.glDisable(3042);
         set3DMode();
      }
   }

   public static void drawStringWithShadow(String s, float x, float y, TrueTypeFont font, float scaleX, float scaleY, float ... rgba) {
      drawString(StringUtils.stripControlCodes(s), x + 0.5F, y + 0.5F, font, scaleX, scaleY, new float[]{0.0F, 0.0F, 0.0F, 1.0F});
      drawString(s, x, y, font, scaleX, scaleY, rgba);
   }

   private static void set2DMode() {
      Minecraft mc = Minecraft.getMinecraft();
      GL11.glMatrixMode(5889);
      GL11.glPushMatrix();
      GL11.glLoadIdentity();
      GL11.glOrtho(0.0D, (double)mc.displayWidth, 0.0D, (double)mc.displayHeight, -1.0D, 1.0D);
      GL11.glMatrixMode(5888);
      GL11.glPushMatrix();
      GL11.glLoadIdentity();
   }

   private static void set3DMode() {
      GL11.glMatrixMode(5889);
      GL11.glPopMatrix();
      GL11.glMatrixMode(5888);
      GL11.glPopMatrix();
      Minecraft mc = Minecraft.getMinecraft();
      mc.entityRenderer.setupOverlayRendering();
   }
}
